# Create Tasks

> Source: https://truto.one/docs/api-reference/unified-crm-api/tasks/create/

`POST /unified/crm/tasks`

Resource: **Tasks** · API: **Unified CRM API**

## Supported integrations

Attio, Capsule, Close, Freshsales, Highlevel, HubSpot, Insightly, Keap, OnePageCRM, Pipedrive, Planhat, Salesflare, Salesforce, Teamleader, Wix, Zendesk Sell, Zoho CRM

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`contact`** _(array<object>)_
  The task's contact

## Request body

- **`content`** _(string)_
  The task's content
- **`account`** _(object)_
  The task's account
  - **`id`** _(string, required)_
    The account's unique identifier
- **`contact`** _(array<object>)_
  The task's contact
  - **`id`** _(string)_
    The contact's unique identifier
  - **`name`** _(string)_
    The contact's name
- **`status`** _(string)_
  The task's status
  Allowed: `open`, `completed`, `open`, `completed`, `open`, `completed`, `open`, `completed`, `open`, `completed`, `deferred`, `waiting` (+8 more)
- **`due_date`** _(string)_
  The date and time of the task's due date
- **`owner`** _(object)_
  The task's owner
  - **`id`** _(string, required)_
    The owner's unique identifier
  - **`name`** _(string)_
    The owner's name
- **`subject`** _(string)_
  The task's subject
- **`opportunity`** _(array<object>)_
  The opportunity to be associated with the task.
  - **`id`** _(string, required)_
    The unique identifier of the opportunity.
  - **`name`** _(string)_
    The opportunity's name
- **`completed_at`** _(string)_
  The date and time of the task's completion
- **`created_at`** _(string)_
  The date and time of the task's creation
- **`owner_id`** _(unknown)_
- **`body`** _(unknown)_
- **`custom_fields`** _(unknown)_
- **`type`** _(object)_
  The task's type
  - **`id`** _(string)_
    The type's unique identifier
  - **`name`** _(string)_
    The type's name
- **`priority`** _(unknown)_
- **`lead`** _(array<object>)_
  The lead to be associated with the task.
  - **`id`** _(string, required)_
    The unique identifier of the lead.
  - **`name`** _(string)_
    The lead's name
- **`description`** _(unknown)_
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The task's unique identifier
- **`subject`** _(string)_
  The task's subject
- **`content`** _(string)_
  The task's content
- **`type`** _(object)_
  The task's type
  - **`id`** _(string)_
    The type's unique identifier
  - **`name`** _(string)_
    The type's name
- **`owner`** _(object)_
  The task's owner
  - **`id`** _(string)_
    The owner's unique identifier
  - **`name`** _(string)_
    The owner's name
- **`account`** _(object)_
  The task's account
  - **`id`** _(string)_
    The account's unique identifier
- **`contact`** _(array<object>)_
  The task's contact
  - **`id`** _(string)_
    The contact's unique identifier
  - **`name`** _(string)_
    The contact's name
- **`opportunity`** _(array<object>)_
  The task's opportunity
  - **`id`** _(string)_
    The opportunity's unique identifier
  - **`name`** _(string)_
    The opportunity's name
- **`lead`** _(array<object>)_
  The task's lead
  - **`id`** _(string)_
    The lead's unique identifier
  - **`name`** _(string)_
    The lead's name
- **`completed_at`** _(string)_
  The date and time of the task's completion
- **`due_date`** _(string)_
  The date and time of the task's due date
- **`status`** _(string)_
  The task's status
  Allowed: `open`, `completed`
- **`created_at`** _(string)_
  The date and time of the task's creation
- **`updated_at`** _(string)_
  The date and time of the task's last update
- **`etag`** _(string)_
  The unique identifier for the specific version of the resource.
- **`urls`** _(array<object>)_
  The task's urls
  - **`url`** _(string)_
    The task's URL
  - **`type`** _(string)_
    The task's URL type
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/crm/tasks?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "content": "your_content",
  "account": {},
  "contact": [],
  "status": "open",
  "due_date": "your_due_date",
  "owner": {},
  "subject": "your_subject",
  "opportunity": [],
  "completed_at": "your_completed_at",
  "created_at": "your_created_at",
  "type": {},
  "lead": [],
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "content": "your_content",
  "account": {},
  "contact": [],
  "status": "open",
  "due_date": "your_due_date",
  "owner": {},
  "subject": "your_subject",
  "opportunity": [],
  "completed_at": "your_completed_at",
  "created_at": "your_created_at",
  "type": {},
  "lead": [],
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/crm/tasks?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/crm/tasks"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "content": "your_content",
    "account": {},
    "contact": [],
    "status": "open",
    "due_date": "your_due_date",
    "owner": {},
    "subject": "your_subject",
    "opportunity": [],
    "completed_at": "your_completed_at",
    "created_at": "your_created_at",
    "type": {},
    "lead": [],
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'crm',
  'tasks',
  {
  "content": "your_content",
  "account": {},
  "contact": [],
  "status": "open",
  "due_date": "your_due_date",
  "owner": {},
  "subject": "your_subject",
  "opportunity": [],
  "completed_at": "your_completed_at",
  "created_at": "your_created_at",
  "type": {},
  "lead": [],
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "crm",
        "tasks",
        {
        "content": "your_content",
        "account": {},
        "contact": [],
        "status": "open",
        "due_date": "your_due_date",
        "owner": {},
        "subject": "your_subject",
        "opportunity": [],
        "completed_at": "your_completed_at",
        "created_at": "your_created_at",
        "type": {},
        "lead": [],
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
